Attribute VB_Name = "Rutinas"
Option Explicit

'==============================================================================
'
'   Name    : Rutinas
'   Author  : Jota Desarrollo de Software
'   Date    : 01-Sep-2017       Last Update : 20-Nov-2017
'
'   Notes   : Archivo de Rutinas
'
'===============================================================================

'===============================================================================
'Declaracin de variables
'===============================================================================

Public intBoard As Integer          'Tablero seleccionado
Public intCols As Integer           'Nmero de columnas del tablero
Public intRows As Integer           'Nmero de filas del tablero
Public intMines As Integer          'Nmero de casillas con minas
Public strBestTimes(2) As String    'Mejores tiempos de cada tablero
Public strBestNames(2) As String    'Nombres de los mejores tiempos de cada tablero
Public blnCClock As Boolean         'Indica que se est jugando contrarreloj

'======================================================================
'   Declaracin de Subrutinas y Funciones
'======================================================================

'Sub        : Main()
'             Subrutina de inicio del sistema

Private Sub Main()
Dim i As Integer

    InitCommonControls
    
    blnCClock = IIf(ReadINI("OPTIONS", "CounterClock", App.Path & "\Config.ini") = "T", True, False)
    intBoard = MyVal(ReadINI("OPTIONS", "Board", App.Path & "\Config.ini"))
    
    'Si es un tablero personalizado, recuperar la composicin del mismo
    If intBoard = 4 Then
        intCols = MyVal(ReadINI("OPTIONS", "BoardCols", App.Path & "\Config.ini"))
        intRows = MyVal(ReadINI("OPTIONS", "BoardRows", App.Path & "\Config.ini"))
        intMines = MyVal(ReadINI("OPTIONS", "BoardMines", App.Path & "\Config.ini"))
    End If
    
    For i = 0 To 2
        strBestTimes(i) = ReadINI("BESTTIME", "Time" & i, App.Path & "\Config.ini")
        strBestNames(i) = ReadINI("BESTTIME", "Name" & i, App.Path & "\Config.ini")
    
        strBestTimes(i) = IIf(Trim(strBestTimes(i)) = "", "60:00", strBestTimes(i))
        strBestNames(i) = IIf(Trim(strBestNames(i)) = "", "Jota", strBestNames(i))
    Next
    
    frmMain.Show
End Sub


'Sub    : Sel(pobjTextBox as TextBox)
'Notes  : Selecciona todo el texto en un textbox

Public Sub Sel(pobjTextBox As Object)
    With pobjTextBox
        .SelStart = 0
        .SelLength = Len(.Text)
    End With
End Sub


'Function   : Aleatorio(plngMin As Long, plngMax As Long) As Long
'Notes      : Retorna un nmero aleatorio entre el mnimo y el mximo que recibe como parmetro.
'Parameters : plngMin   Mnimo a retornar
'             plngMax   Mximo a retornar

Public Function Aleatorio(plngMin As Long, plngMax As Long) As Long
    Randomize
    Aleatorio = CLng((plngMin - plngMax) * Rnd + plngMax)
End Function


'Function   : MyVal(pstrText As String) As Double
'Notes      : Retorna el VAL de pstrText, cambiando previamente las , por .
'Parameters : pstrText      Cadena a convertir

Public Function MyVal(pstrText As String) As Double
    MyVal = Val(Replace(Replace(pstrText, ".", ""), ",", "."))
End Function


'Function   : Num(pintKeyAscii AS Integer)
'             Comprueba los datos ingresados en un textbox (tecla por tecla)
'             permitiendo slo los nmeros.
'             Esta funcin debe usarse en el evento KeyDown de un TextBox, de la siguiente forma:
'             pintKeyAscii=Num(pintKeyAscii)
'Parameters : pintKeyAscii  Cdigo Ascii de la tecla pulsada

Public Function Num(pintKeyAscii As Integer)
Dim strValid As String * 11
    strValid = "1234567890" + Chr(8)
    
    If InStr(strValid, Chr(pintKeyAscii)) = 0 Then pintKeyAscii = 0: Beep
    
    Num = pintKeyAscii
End Function
