Attribute VB_Name = "TemasXP"
'------------------------------------------------------------------------------
' Mdulo para contener las rutinas de creacin de picFrm            (19/Ago/03)
' Automatizar los formularios de VB para usar temas de XP
'
' Guillermo 'guille' Som, 2003
'------------------------------------------------------------------------------
Option Explicit

' constantes para la posicin del picture dentro del Frame
Const picL As Long = 30&, picW As Long = 90&
' estos dos valores deben ir "emparejados" con una diferencia de 30
Const picT As Long = 190&, picH As Long = picT + 30& '225&

Public Function CrearPicFrm(ByVal frm As Form, Optional ByVal noBuscarOption As Boolean = False) As String
    ' Esta rutina comprobar si hay algn option con un valor Top inferior a picT,
    ' en ese caso llamar a crearPicFrm2.
    ' Si noBuscarOption = True, se usar crearPicFrm1 sin usar el bucle de buscar
    ' Indicar ese valor si sabemos que no hay ningn OptionButton en una parte alta de un frame
    Dim s As String
    '
#If ESVB5 Then
    's = "VB5"
    s = "Usando crearPicFrmVB5"
    crearPicFrmVB5 frm
#Else
    '
    Dim usarPicFrm2 As Boolean
    Dim c As Control
    '
    s = "VB6"
    '
    If noBuscarOption = False Then
        On Error Resume Next
        '
        For Each c In frm.Controls
            If TypeOf c.Container Is Frame Then
                If c.Top < picT Then
                    Select Case TypeName(c)
                    Case "Frame", "CommandButton", "OptionButton"
                        usarPicFrm2 = True
                        Exit For
                    End Select
                End If
            End If
        Next
        '
        Err = 0
    End If
    '
    If usarPicFrm2 Then
        s = s & " usando crearPicFrm2"
        crearPicFrm2 frm
    Else
        s = s & " usando crearPicFrm1"
        crearPicFrm1 frm
    End If
    '
#End If
    '
    ' devolver la cadena informativa con los Pictures creados y la rutina usada
    CrearPicFrm = s & ", picFrm usados: " & frm.picFrm.Count & " (0 a " & frm.picFrm.Count - 1 & ")"
End Function
'
#If ESVB5 Then
'
Private Sub crearPicFrmVB5(ByVal frm As Form)
    ' Crea los pictures que contendr los controles                 (19/Ago/03)
    ' que estn dentro de otros frames.
    ' Versin para VB5.
    ' En VB5 slo dan problemas los frames.
    '
    '--------------------------------------------------------------------------
    ' La nica pega de este cdigo, con diferencia al de VB6, es que los
    ' Options en VB5 se quedan transparentes.
    ' Pero si se usa el cdigo de VB6, no se ven transparentes,
    ' aunque se usaran ms controles picFrm (igual que en VB6)
    '--------------------------------------------------------------------------
    '
    Dim nPicFrm As Long
    Dim c As Control
    Dim pic As PictureBox
    '
    On Error Resume Next
    '
    nPicFrm = -1
    For Each c In frm.Controls
        If TypeOf c.Container Is Frame Then
            Select Case TypeName(c)
            ' En VB5 slo se pondrn en pictures los Frames
            Case "Frame"
                nPicFrm = nPicFrm + 1
                If nPicFrm > 0 Then
                    Load frm.picFrm(nPicFrm)
                End If
                Set pic = frm.picFrm(nPicFrm)
                Set pic.Container = c.Container
                With pic
                    .BorderStyle = 0
                    .Visible = True
                    .Move c.Left, c.Top, c.Width, c.Height
                    '.ZOrder 0
                    .BackColor = .Container.BackColor
                End With
                Set c.Container = pic
                c.Move 0, 0
                c.ZOrder
            End Select
        End If
    Next
    '
End Sub
'
#Else
'
Private Sub crearPicFrm1(ByVal frm As Form)
    ' Usar este cdigo si no hay ningn control "problemtico" justo arriba de un Frame
    ' ya que no se vera bien.
    Dim nPicFrm As Long
    Dim c As Control
    Dim c1 As Control
    Dim pic As PictureBox
    '
    On Error Resume Next
    '
    nPicFrm = -1
    For Each c In frm.Controls
        If TypeOf c Is Frame Then
            nPicFrm = nPicFrm + 1
            If nPicFrm > 0 Then
                Load frm.picFrm(nPicFrm)
            End If
            Set pic = frm.picFrm(nPicFrm)
            Set pic.Container = c
            With pic
                .BorderStyle = 0
                .Visible = True
                .Move picL, picT, c.Width - picW, c.Height - picH
                .ZOrder 0
                .BackColor = .Container.BackColor
            End With
            For Each c1 In frm.Controls
                If c1.Container Is c Then
                    ' no tener en cuenta los picFrm
                    If Not (c1 Is pic) Then
                        ' si el control est posicionado
                        ' a menos de 180 (picT), no incluirlo en este picture
                        If c1.Top > picT Then
                            Set c1.Container = pic
                            c1.Move c1.Left - picL, c1.Top - picT
                        End If
                        c1.ZOrder
                    End If
                End If
            Next
        End If
    Next
    '
    'Debug.Print "Total picFrm en crearPicFrm= "; nPicFrm
    Err.Clear
    '
End Sub

Private Sub crearPicFrm2(ByVal frm As Form)

    '
    ' Crea los pictures que contendr los controles                 (19/Ago/03)
    ' que estn dentro de otros frames.
    ' Versin para VB6.
    ' En VB6 dan problemas los frames, commandbutons y options.
    '
    ' Esta rutina "maneja" bien los Options, pero "consume" ms pictures
    '
    Dim nPicFrm As Long
    Dim c As Control
    Dim pic As PictureBox
    '
    Dim i As Long, j As Long
    Dim minL As Long, minT As Long, minW As Long
    Dim b As Long
    Dim nOpB As Long
    Dim opB() As OptionButton
    '
    On Error Resume Next
    '
    nOpB = -1
    nPicFrm = -1
    For Each c In frm.Controls
        If TypeOf c.Container Is Frame Then
            Select Case TypeName(c)
            ' Debido a que los OptionButton no funcionaran bien    (19/Ago/03)
            ' al no estar agrupados, mejor agruparlos en un contenedor
            Case "CommandButton", "Frame"
                nPicFrm = nPicFrm + 1
                If nPicFrm > 0 Then
                    Load frm.picFrm(nPicFrm)
                End If
                Set pic = frm.picFrm(nPicFrm)
                Set pic.Container = c.Container
                With pic
                    .BorderStyle = 0
                    .Visible = True
                    .Move c.Left, c.Top, c.Width, c.Height
                    '.ZOrder 0
                    .BackColor = .Container.BackColor
                End With
                Set c.Container = pic
                c.Move 0, 0
                c.ZOrder
            Case "OptionButton"
                ' aadirlo al array
                nOpB = nOpB + 1
                ReDim Preserve opB(nOpB)
                Set opB(nOpB) = c
            End Select
        End If
    Next
    ' comprobar los OptionButtons que estn en un mismo frame       (19/Ago/03)
    For i = 0 To nOpB
        If TypeOf opB(i).Container Is Frame Then
            Set c = opB(i).Container
            minT = opB(i).Top
            minW = opB(i).Left + opB(i).Width
            b = i
            nPicFrm = nPicFrm + 1
            If nPicFrm > 0 Then
                Load frm.picFrm(nPicFrm)
            End If
            Set pic = frm.picFrm(nPicFrm)
            Set pic.Container = opB(i).Container
            minL = opB(i).Left
            pic.Tag = "nPicFrm" & nPicFrm
            Set opB(i).Container = pic
            For j = i + 1 To nOpB
                If opB(j).Container Is c Then
                    If opB(j).Top < minT Then
                        minT = opB(j).Top
                    Else
                        ' b contendr el que est ms "abajo"
                        b = j
                    End If
                    If opB(j).Left < minL Then
                        minL = opB(j).Left
                    End If
                    If opB(j).Left + opB(j).Width > minW Then
                        minW = opB(j).Left + opB(j).Width
                    End If
                    Set opB(j).Container = pic
                    opB(j).ZOrder
                End If
            Next
            With pic
                .BorderStyle = 0
                .Visible = True
                .Move minL, minT, minW - minL, (opB(b).Top + opB(b).Height - minT)
                ' ponerlo debajo, por si hubiese algn otro control "desplazado"
                ' por ejemplo en el caso de que los Options estn uno al lado del otro
                .ZOrder 1
                .BackColor = .Container.BackColor
            End With
            ' posicionar correctamente los Options
            For j = i To nOpB
                If opB(j).Container.Tag = opB(i).Container.Tag Then
                    opB(j).Top = opB(j).Top - minT
                    opB(j).Left = opB(j).Left - minL 'pic.Left
                End If
            Next
        End If
    Next
    '
    '
    'Debug.Print "Total picFrm en crearPicFrm2= "; nPicFrm
    Err.Number = 0
End Sub
'
#End If
